searchNodes=[{"doc":"Hui 辉 (&quot;shine&quot; in Chinese) is an Elixir client and library for Solr enterprise search platform.UsageSearching Solr: q/1, q/6, search/2, search/7Updating: update/3, delete/3, delete_by_query/3, commit/2Other: suggest/2, suggest/5README","ref":"Hui.html","title":"Hui","type":"module"},{"doc":"Commit any added or deleted Solr documents to the index.This provides a (separate) mechanism to commit previously added or deleted documents to Solr index for different updating and index maintenance scenarios. By default, the commit waits for a new Solr searcher to be regenerated, so that the commit result is made available for search.An index/update handler endpoint should be specified through a Hui.URL.t/0 struct or a URL config key. A JSON content type header for the URL is required so that Solr knows the incoming data format and can process data accordingly.Example # Index handler for JSON-formatted update headers = [{&quot;Content-type&quot;, &quot;application/json&quot;}] url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;update&quot;, headers: headers} Hui.commit(url) # commits, make new docs available for search Hui.commit(url, false) # commits op only, new docs to be made available laterUse Hui.Query.Update.t/0 struct for other types of commit and index optimisation, e.g. expunge deleted docs to physically remove docs from the index, which could be a system-intensive operation.","ref":"Hui.html#commit/2","title":"Hui.commit/2","type":"function"},{"doc":"Deletes Solr documents.This function accepts a single or list of IDs and immediately delete the corresponding documents from the Solr index (commit by default).An index/update handler endpoint should be specified through a Hui.URL.t/0 struct or a URL config key. A JSON content type header for the URL is required so that Solr knows the incoming data format and can process data accordingly.Example # Index handler for JSON-formatted update headers = [{&quot;Content-type&quot;, &quot;application/json&quot;}] url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;update&quot;, headers: headers} Hui.delete(url, &quot;tt2358891&quot;) # delete a single doc Hui.delete(url, [&quot;tt2358891&quot;, &quot;tt1602620&quot;]) # delete a list of docs Hui.delete(url, [&quot;tt2358891&quot;, &quot;tt1602620&quot;], false) # delete without immediate commit","ref":"Hui.html#delete/3","title":"Hui.delete/3","type":"function"},{"doc":"Deletes Solr documents by filter queries.This function accepts a single or list of filter queries and immediately delete the corresponding documents from the Solr index (commit by default).An index/update handler endpoint should be specified through a Hui.URL.t/0 struct or a URL config key. A JSON content type header for the URL is required so that Solr knows the incoming data format and can process data accordingly.Example # Index handler for JSON-formatted update headers = [{&quot;Content-type&quot;, &quot;application/json&quot;}] url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;update&quot;, headers: headers} Hui.delete_by_query(url, &quot;name:Persona&quot;) # delete with a single filter Hui.delete_by_query(url, [&quot;genre:Drama&quot;, &quot;name:Persona&quot;]) # delete with a list of filters","ref":"Hui.html#delete_by_query/3","title":"Hui.delete_by_query/3","type":"function"},{"doc":"Issues a get request of Solr query to a specific endpoint.The query can be a keyword list or a list of Hui query structs (query/0).Example - parameters url = %Hul.URL{url: &quot;http://...&quot;} # query via a list of keywords, which are unbound and sent to Solr directly Hui.get(url, q: &quot;glen cova&quot;, facet: &quot;true&quot;, &quot;facet.field&quot;: [&quot;type&quot;, &quot;year&quot;]) # query via Hui structs alias Hui.Query Hui.get(url, %Query.DisMax{q: &quot;glen cova&quot;}) Hui.get(url, [%Query.DisMax{q: &quot;glen&quot;}, %Query.Facet{field: [&quot;type&quot;, &quot;year&quot;]}])The use of structs is more idiomatic and succinct. It is bound to qualified Solr fields.See Hui.URL.t/0 struct about specifying HTTP headers and options for a request, e.g. timeout, recv_timeout, max_redirect etc.","ref":"Hui.html#get/2","title":"Hui.get/2","type":"function"},{"doc":"Issues a POST update request to a specific Solr endpoint, for data indexing and deletion.","ref":"Hui.html#post/2","title":"Hui.post/2","type":"function"},{"doc":"Issue a keyword list or structured query to the default Solr endpoint.The query can either be a keyword list or a list of Hui structs - see Hui.solr_struct/0. This function is a shortcut for search/2 with :default as URL key.Example Hui.q(q: &quot;loch&quot;, rows: 5, facet: true, &quot;facet.field&quot;: [&quot;year&quot;, &quot;subject&quot;]) # supply a list of Hui structs for more complex query, e.g. faceting alias Hui.Query Hui.q([%Query.Standard{q: &quot;author:I*&quot;}, %Query.Facet{field: [&quot;cat&quot;, &quot;author&quot;], mincount: 1}]) # DisMax x = %Query.Dismax{q: &quot;run&quot;, qf: &quot;description^2.3 title&quot;, mm: &quot;2&lt;-25% 9&lt;-3&quot;} y = %Query.Common{rows: 10, start: 10, fq: [&quot;edited:true&quot;]} z = %Query.Facet{field: [&quot;cat&quot;, &quot;author&quot;], mincount: 1} Hui.q([x, y, z])","ref":"Hui.html#q/1","title":"Hui.q/1","type":"function"},{"doc":"Convenience function for issuing various typical queries to the default Solr endpoint.Example Hui.q(&quot;scott&quot;) # keywords Hui.q(&quot;loch&quot;, 10, 20) # .. with paging parameters Hui.q(&quot;\\&quot;apache documentation\\&quot;~5&quot;, 1, 0, &quot;stream_content_type_str:text/html&quot;, [&quot;subject&quot;]) # .. plus filter(s) and facet fields","ref":"Hui.html#q/6","title":"Hui.q/6","type":"function"},{"doc":"Issue a keyword list or structured query to a specified Solr endpoint.Example - parameters url = &quot;http://localhost:8983/solr/collection&quot; # a keyword list of arbitrary parameters Hui.search(url, q: &quot;edinburgh&quot;, rows: 10) # supply a list of Hui structs for more complex query e.g. DisMax alias Hui.Query x = %Query.DisMax{q: &quot;run&quot;, qf: &quot;description^2.3 title&quot;, mm: &quot;2&lt;-25% 9&lt;-3&quot;} y = %Query.Common{rows: 10, start: 10, fq: [&quot;edited:true&quot;]} z = %Query.Facet{field: [&quot;cat&quot;, &quot;author_str&quot;], mincount: 1} Hui.search(url, [x, y, z]) # SolrCloud query x = %Query.DisMax{q: &quot;john&quot;} y = %Query.Common{collection: &quot;library,commons&quot;, rows: 10, distrib: true, &quot;shards.tolerant&quot;: true, &quot;shards.info&quot;: true} Hui.search(url, [x,y]) # With results highlighting (snippets) x = %Query.Standard{q: &quot;features:photo&quot;} y = %Query.Highlight{fl: &quot;features&quot;, usePhraseHighlighter: true, fragsize: 250, snippets: 3 } Hui.search(url, [x, y])Example - faceting alias Hui.Query range1 = %Query.FacetRange{range: &quot;price&quot;, start: 0, end: 100, gap: 10, per_field: true} range2 = %Query.FacetRange{range: &quot;popularity&quot;, start: 0, end: 5, gap: 1, per_field: true} x = %Query.DisMax{q: &quot;ivan&quot;} y = %Query.Facet{field: [&quot;cat&quot;, &quot;author_str&quot;], mincount: 1, range: [range1, range2]} Hui.search(:default, [x, y])The above Hui.search(:default, [x, y]) example issues a request that resulted in the following Solr response header showing the corresponding generated and encoded parameters.&quot;responseHeader&quot; =&gt; %{ &quot;QTime&quot; =&gt; 106, &quot;params&quot; =&gt; %{ &quot;f.popularity.facet.range.end&quot; =&gt; &quot;5&quot;, &quot;f.popularity.facet.range.gap&quot; =&gt; &quot;1&quot;, &quot;f.popularity.facet.range.start&quot; =&gt; &quot;0&quot;, &quot;f.price.facet.range.end&quot; =&gt; &quot;100&quot;, &quot;f.price.facet.range.gap&quot; =&gt; &quot;10&quot;, &quot;f.price.facet.range.start&quot; =&gt; &quot;0&quot;, &quot;facet&quot; =&gt; &quot;true&quot;, &quot;facet.field&quot; =&gt; [&quot;cat&quot;, &quot;author_str&quot;], &quot;facet.mincount&quot; =&gt; &quot;1&quot;, &quot;facet.range&quot; =&gt; [&quot;price&quot;, &quot;popularity&quot;], &quot;q&quot; =&gt; &quot;ivan&quot; }, &quot;status&quot; =&gt; 0, &quot;zkConnected&quot; =&gt; true }","ref":"Hui.html#search/2","title":"Hui.search/2","type":"function"},{"doc":"Convenience function for issuing various typical queries to a specified Solr endpoint.See q/6.","ref":"Hui.html#search/7","title":"Hui.search/7","type":"function"},{"doc":"Issue a structured suggest query to a specified Solr endpoint.Example suggest_query = %Hui.Query.Suggest{q: &quot;ha&quot;, count: 10, dictionary: &quot;name_infix&quot;} Hui.suggest(:library, suggest_query)","ref":"Hui.html#suggest/2","title":"Hui.suggest/2","type":"function"},{"doc":"Convenience function for issuing a suggester query to a specified Solr endpoint.Example Hui.suggest(:autocomplete, &quot;t&quot;) Hui.suggest(:autocomplete, &quot;bo&quot;, 5, [&quot;name_infix&quot;, &quot;ln_prefix&quot;, &quot;fn_prefix&quot;], &quot;1939&quot;)","ref":"Hui.html#suggest/5","title":"Hui.suggest/5","type":"function"},{"doc":"Updates or adds Solr documents to an index or collection.This function accepts documents as map (single or a list) and commits the docs to the index immediately by default - set commit to false for manual or auto commits later. It can also operate in update struct and binary modes, the former uses the Hui.Query.Update.t/0 struct while the latter acepts text containing any valid Solr update data or commands.An index/update handler endpoint should be specified through a Hui.URL.t/0 struct or a URL config key. A content type header is required so that Solr knows the incoming data format (JSON, XML etc.) and can process data accordingly.Example - map, list and binary data # Index handler for JSON-formatted update headers = [{&quot;Content-type&quot;, &quot;application/json&quot;}] url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;update&quot;, headers: headers} # Solr docs in maps doc1 = %{ &quot;actors&quot; =&gt; [&quot;Ingrid Bergman&quot;, &quot;Liv Ullmann&quot;, &quot;Lena Nyman&quot;, &quot;Halvar Björk&quot;], &quot;desc&quot; =&gt; &quot;A married daughter who longs for her mother&#39;s love is visited by the latter, a successful concert pianist.&quot;, &quot;directed_by&quot; =&gt; [&quot;Ingmar Bergman&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;, &quot;Music&quot;], &quot;id&quot; =&gt; &quot;tt0077711&quot;, &quot;initial_release_date&quot; =&gt; &quot;1978-10-08&quot;, &quot;name&quot; =&gt; &quot;Autumn Sonata&quot; } doc2 = %{ &quot;actors&quot; =&gt; [&quot;Bibi Andersson&quot;, &quot;Liv Ullmann&quot;, &quot;Margaretha Krook&quot;], &quot;desc&quot; =&gt; &quot;A nurse is put in charge of a mute actress and finds that their personas are melding together.&quot;, &quot;directed_by&quot; =&gt; [&quot;Ingmar Bergman&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;, &quot;Thriller&quot;], &quot;id&quot; =&gt; &quot;tt0060827&quot;, &quot;initial_release_date&quot; =&gt; &quot;1967-09-21&quot;, &quot;name&quot; =&gt; &quot;Persona&quot; } Hui.update(url, doc1) # add a single doc Hui.update(url, [doc1, doc2]) # add a list of docs # Don&#39;t commit the docs e.g. mass ingestion when index handler is setup for autocommit. Hui.update(url, [doc1, doc2], false) # Send to a configured endpoint Hui.update(:updater, [doc1, doc2]) # Binary mode, add and commit a doc Hui.update(url, &quot;{\\&quot;add\\&quot;:{\\&quot;doc\\&quot;:{\\&quot;name\\&quot;:\\&quot;Blade Runner\\&quot;,\\&quot;id\\&quot;:\\&quot;tt0083658\\&quot;,..}},\\&quot;commit\\&quot;:{}}&quot;) # Binary mode, delete a doc via XML headers = [{&quot;Content-type&quot;, &quot;application/xml&quot;}] url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;update&quot;, headers: headers} Hui.update(url, &quot;&lt;delete&gt;&lt;id&gt;9780141981727&lt;/id&gt;&lt;/delete&gt;&quot;) Example - Hui.Query.Update.t/0 and other update options # url, doc1, doc2 from the above example ... # Hui.Query.Update struct command for updating and committing the docs to Solr within 5 seconds alias Hui.Query x = %Query.Update{doc: [doc1, doc2], commitWithin: 5000, overwrite: true} {status, resp} = Hui.update(url, x) # Delete the docs by IDs, with a URL key from configuration {status, resp} = Hui.update(:library_update, %Query.Update{delete_id: [&quot;tt1316540&quot;, &quot;tt1650453&quot;]}) # Commit and optimise index, keep max index segments at 10 {status, resp} = Hui.update(url, %Query.Update{commit: true, waitSearcher: true, optimize: true, maxSegments: 10}) # Commit index, expunge deleted docs {status, resp} = Hui.update(url, %Query.Update{commit: true, expungeDeletes: true})","ref":"Hui.html#update/3","title":"Hui.update/3","type":"function"},{"doc":"","ref":"Hui.html#t:faceting_struct/0","title":"Hui.faceting_struct/0","type":"type"},{"doc":"","ref":"Hui.html#t:highlighting_struct/0","title":"Hui.highlighting_struct/0","type":"type"},{"doc":"","ref":"Hui.html#t:http_response/0","title":"Hui.http_response/0","type":"type"},{"doc":"","ref":"Hui.html#t:misc_struct/0","title":"Hui.misc_struct/0","type":"type"},{"doc":"","ref":"Hui.html#t:query/0","title":"Hui.query/0","type":"type"},{"doc":"","ref":"Hui.html#t:querying_struct/0","title":"Hui.querying_struct/0","type":"type"},{"doc":"","ref":"Hui.html#t:solr_struct/0","title":"Hui.solr_struct/0","type":"type"},{"doc":"","ref":"Hui.html#t:update_query/0","title":"Hui.update_query/0","type":"type"},{"doc":"","ref":"Hui.html#t:url/0","title":"Hui.url/0","type":"type"},{"doc":"Utilities for encoding Solr query and update data structures.","ref":"Hui.Encode.html","title":"Hui.Encode","type":"module"},{"doc":"Encodes keywords list into IO data.","ref":"Hui.Encode.html#encode/1","title":"Hui.Encode.encode/1","type":"function"},{"doc":"Encodes keywords of Solr query structs that require special handling into IO data.","ref":"Hui.Encode.html#encode/2","title":"Hui.Encode.encode/2","type":"function"},{"doc":"","ref":"Hui.Encode.html#t:options/0","title":"Hui.Encode.options/0","type":"type"},{"doc":"A protocol that underpins Solr query encoding.","ref":"Hui.Encoder.html","title":"Hui.Encoder","type":"protocol"},{"doc":"Encode various Solr query types - Hui.query/0 into string.Example - encoding keyword listiex&gt; alias Hui.Encoder iex&gt; Encoder.encode(q: &quot;loch&quot;, start: 10, rows: 10, fq: [&quot;type:image&quot;, &quot;year:[2001 TO 2007]&quot;]) &quot;q=loch&amp;start=10&amp;rows=10&amp;fq=type%3Aimage&amp;fq=year%3A%5B2001+TO+2007%5D&quot;Example - encoding query structsiex&gt; alias Hui.Query.{DisMax,Highlight,Update} iex&gt; %DisMax{q: &quot;loch&quot;, qf: &quot;description^2.3 title&quot;, mm: &quot;2&lt;-25% 9&lt;-3&quot;} |&gt; Encoder.encode &quot;mm=2%3C-25%25+9%3C-3&amp;q=loch&amp;qf=description%5E2.3+title&quot; iex&gt; %Highlight{fl: &quot;title,words&quot;, usePhraseHighlighter: true, fragsize: 250} |&gt; Encoder.encode &quot;hl.fl=title%2Cwords&amp;hl.fragsize=250&amp;hl=true&amp;hl.usePhraseHighlighter=true&quot; iex&gt; %Query.Update{delete_id: [&quot;tt1316540&quot;, &quot;tt1650453&quot;]} |&gt; Encoder.encode &quot;{&quot;delete&quot;:{&quot;id&quot;:&quot;tt1316540&quot;},&quot;delete&quot;:{&quot;id&quot;:&quot;tt1650453&quot;}}&quot;See Hui.Query.Facet, Hui.Query.FacetRange, Hui.Query.FacetInterval, Hui.Query.Update for more examples.","ref":"Hui.Encoder.html#encode/1","title":"Hui.Encoder.encode/1","type":"function"},{"doc":"Encode various Solr query types - Hui.query/0 into IO data.Examplesiex&gt; Hui.Encoder.encode_to_iodata(q: &quot;loch&quot;, facet: true, &quot;facet.field&quot;: [&quot;type&quot;, &quot;year&quot;]) [ &quot;q&quot;, 61, &quot;loch&quot;, 38, [ &quot;facet&quot;, 61, &quot;true&quot;, 38, [&quot;facet.field&quot;, 61, &quot;type&quot;, 38, [&quot;facet.field&quot;, 61, &quot;year&quot;]] ] ] iex&gt; %Hui.Query.Update{delete_id: [&quot;tt1316540&quot;, &quot;tt1650453&quot;]} |&gt; Hui.Encoder.encode_to_iodata [ 123, [ [ [ 34, &quot;delete&quot;, 34, 58, [123, [[34, &quot;id&quot;, 34], 58, [34, [[] | &quot;tt1316540&quot;], 34]], 125] ], 44, [ 34, &quot;delete&quot;, 34, 58, [123, [[34, &quot;id&quot;, 34], 58, [34, [[] | &quot;tt1650453&quot;], 34]], 125] ] ] ], 125 ]IO data encodingencode_to_iodata/1 enables the built-in structs encoder to return IO data which can be sent directly to IO functions or over the socket, to leverage Erlang runtime and some HTTP client features for lower memory usage and increased performance.","ref":"Hui.Encoder.html#encode_to_iodata/1","title":"Hui.Encoder.encode_to_iodata/1","type":"function"},{"doc":"","ref":"Hui.Encoder.html#t:query/0","title":"Hui.Encoder.query/0","type":"type"},{"doc":"","ref":"Hui.Encoder.html#t:t/0","title":"Hui.Encoder.t/0","type":"type"},{"doc":"","ref":"Hui.Http.html","title":"Hui.Http","type":"behaviour"},{"doc":"","ref":"Hui.Http.html#c:dispatch/1","title":"Hui.Http.dispatch/1","type":"callback"},{"doc":"","ref":"Hui.Http.html#dispatch/2","title":"Hui.Http.dispatch/2","type":"function"},{"doc":"","ref":"Hui.Http.html#t:response/0","title":"Hui.Http.response/0","type":"type"},{"doc":"","ref":"Hui.Http.html#t:t/0","title":"Hui.Http.t/0","type":"type"},{"doc":"","ref":"Hui.Http.Httpoison.html","title":"Hui.Http.Httpoison","type":"module"},{"doc":"Struct for common and SolrCloud query parameters.See:Common query parametersSolrCloud query routing parametersSolrCloud distributed requests","ref":"Hui.Query.Common.html","title":"Hui.Query.Common","type":"module"},{"doc":"","ref":"Hui.Query.Common.html#new/0","title":"Hui.Query.Common.new/0","type":"function"},{"doc":"","ref":"Hui.Query.Common.html#new/4","title":"Hui.Query.Common.new/4","type":"function"},{"doc":"","ref":"Hui.Query.Common.html#t:debug_query_options/0","title":"Hui.Query.Common.debug_query_options/0","type":"type"},{"doc":"Struct for the common and SolrCloud query parameters.","ref":"Hui.Query.Common.html#t:t/0","title":"Hui.Query.Common.t/0","type":"type"},{"doc":"Struct related to DisMax query.Correspond to the query parsers known as the Maximum Disjunction - DisMax and eDismax (extended version).See below for more details: DisMaxExtended DisMax","ref":"Hui.Query.DisMax.html","title":"Hui.Query.DisMax","type":"module"},{"doc":"","ref":"Hui.Query.DisMax.html#new/0","title":"Hui.Query.DisMax.new/0","type":"function"},{"doc":"","ref":"Hui.Query.DisMax.html#new/3","title":"Hui.Query.DisMax.new/3","type":"function"},{"doc":"Struct for DisMax/eDismax query.","ref":"Hui.Query.DisMax.html#t:t/0","title":"Hui.Query.DisMax.t/0","type":"type"},{"doc":"Struct related to faceting.Exampleiex&gt; x = %Hui.Query.Facet{field: [&quot;type&quot;, &quot;year&quot;], query: &quot;year:[2000 TO NOW]&quot;} %Hui.Query.Facet{ contains: nil, &quot;contains.ignoreCase&quot;: nil, &quot;enum.cache.minDf&quot;: nil, excludeTerms: nil, exists: nil, facet: true, field: [&quot;type&quot;, &quot;year&quot;], interval: nil, limit: nil, matches: nil, method: nil, mincount: nil, missing: nil, offset: nil, &quot;overrequest.count&quot;: nil, &quot;overrequest.ratio&quot;: nil, pivot: nil, &quot;pivot.mincount&quot;: nil, prefix: nil, query: &quot;year:[2000 TO NOW]&quot;, range: nil, sort: nil, threads: nil } iex&gt; x |&gt; Hui.Encoder.encode &quot;facet=true&amp;facet.field=type&amp;facet.field=year&amp;facet.query=year%3A%5B2000+TO+NOW%5D&quot;","ref":"Hui.Query.Facet.html","title":"Hui.Query.Facet","type":"module"},{"doc":"","ref":"Hui.Query.Facet.html#new/0","title":"Hui.Query.Facet.new/0","type":"function"},{"doc":"","ref":"Hui.Query.Facet.html#new/2","title":"Hui.Query.Facet.new/2","type":"function"},{"doc":"Struct for faceting.","ref":"Hui.Query.Facet.html#t:t/0","title":"Hui.Query.Facet.t/0","type":"type"},{"doc":"Struct related to interval faceting query.Exampleiex&gt; x = %Hui.Query.FacetInterval{interval: &quot;price&quot;, set: [&quot;[0,10]&quot;, &quot;(10,100]&quot;]} %Hui.Query.FacetInterval{ interval: &quot;price&quot;, set: [&quot;[0,10]&quot;, &quot;(10,100]&quot;], per_field: false } iex&gt; y = %Hui.Query.Facet{interval: x, field: [&quot;type&quot;, &quot;year&quot;]} %Hui.Query.Facet{ contains: nil, &quot;contains.ignoreCase&quot;: nil, &quot;enum.cache.minDf&quot;: nil, excludeTerms: nil, exists: nil, facet: true, field: [&quot;type&quot;, &quot;year&quot;], interval: %Hui.Query.FacetInterval{ interval: &quot;price&quot;, set: [&quot;[0,10]&quot;, &quot;(10,100]&quot;], per_field: false }, limit: nil, matches: nil, method: nil, mincount: nil, missing: nil, offset: nil, &quot;overrequest.count&quot;: nil, &quot;overrequest.ratio&quot;: nil, pivot: nil, &quot;pivot.mincount&quot;: nil, prefix: nil, query: nil, range: nil, sort: nil, threads: nil } iex&gt; y |&gt; Hui.Encoder.encode # render struct into URL query string with `facet` prefixes &quot;facet=true&amp;facet.field=type&amp;facet.field=year&amp;facet.interval=price&amp;facet.interval.set=%5B0%2C10%5D&amp;facet.interval.set=%2810%2C100%5D&quot;Example - per field intervals, f.[fieldname].facet.intervaliex&gt; x = %Hui.Query.FacetInterval{interval: &quot;price&quot;, set: [&quot;[0,10]&quot;, &quot;(10,100]&quot;], per_field: true} %Hui.Query.FacetInterval{ interval: &quot;price&quot;, set: [&quot;[0,10]&quot;, &quot;(10,100]&quot;], per_field: true } iex&gt; y = %Hui.Query.Facet{field: &quot;type&quot;, interval: x} %Hui.Query.Facet{ contains: nil, &quot;contains.ignoreCase&quot;: nil, &quot;enum.cache.minDf&quot;: nil, excludeTerms: nil, exists: nil, facet: true, field: &quot;type&quot;, interval: %Hui.Query.FacetInterval{ interval: &quot;price&quot;, set: [&quot;[0,10]&quot;, &quot;(10,100]&quot;], per_field: true }, limit: nil, matches: nil, method: nil, mincount: nil, missing: nil, offset: nil, &quot;overrequest.count&quot;: nil, &quot;overrequest.ratio&quot;: nil, pivot: nil, &quot;pivot.mincount&quot;: nil, prefix: nil, query: nil, range: nil, sort: nil, threads: nil } iex&gt; y |&gt; Hui.Encoder.encode &quot;facet=true&amp;facet.field=type&amp;facet.interval=price&amp;f.price.facet.interval.set=%5B0%2C10%5D&amp;f.price.facet.interval.set=%2810%2C100%5D&quot;","ref":"Hui.Query.FacetInterval.html","title":"Hui.Query.FacetInterval","type":"module"},{"doc":"","ref":"Hui.Query.FacetInterval.html#new/0","title":"Hui.Query.FacetInterval.new/0","type":"function"},{"doc":"","ref":"Hui.Query.FacetInterval.html#new/2","title":"Hui.Query.FacetInterval.new/2","type":"function"},{"doc":"Struct for interval faceting parameters, use in conjunction with the faceting struct - Hui.Query.Facet.t/0.","ref":"Hui.Query.FacetInterval.html#t:t/0","title":"Hui.Query.FacetInterval.t/0","type":"type"},{"doc":"Struct related to range faceting query.Exampleiex&gt; x = %Hui.Query.FacetRange{range: &quot;year&quot;, gap: &quot;+10YEARS&quot;, start: 1700, end: 1799} %Hui.Query.FacetRange{ end: 1799, gap: &quot;+10YEARS&quot;, hardend: nil, include: nil, method: nil, other: nil, per_field: false, range: &quot;year&quot;, start: 1700 } iex&gt; y = %Hui.Query.Facet{range: x, field: [&quot;type&quot;, &quot;year&quot;], query: &quot;year:[2000 TO NOW]&quot;} %Hui.Query.Facet{ contains: nil, &quot;contains.ignoreCase&quot;: nil, &quot;enum.cache.minDf&quot;: nil, excludeTerms: nil, exists: nil, facet: true, field: [&quot;type&quot;, &quot;year&quot;], interval: nil, limit: nil, matches: nil, method: nil, mincount: nil, missing: nil, offset: nil, &quot;overrequest.count&quot;: nil, &quot;overrequest.ratio&quot;: nil, pivot: nil, &quot;pivot.mincount&quot;: nil, prefix: nil, query: &quot;year:[2000 TO NOW]&quot;, range: %Hui.Query.FacetRange{ end: 1799, gap: &quot;+10YEARS&quot;, hardend: nil, include: nil, method: nil, other: nil, per_field: false, range: &quot;year&quot;, start: 1700 }, sort: nil, threads: nil } iex&gt; y |&gt; Hui.Encoder.encode # render struct into URL query string with `facet` prefixes &quot;facet=true&amp;facet.field=type&amp;facet.field=year&amp;facet.query=year%3A%5B2000+TO+NOW%5D&amp;facet.range.end=1799&amp;facet.range.gap=%2B10YEARS&amp;facet.range=year&amp;facet.range.start=1700&quot;Example - per field ranges, f.[fieldname].facet.rangeiex&gt; x = %Hui.Query.FacetRange{range: &quot;year&quot;, gap: &quot;+10YEARS&quot;, start: 1700, end: 1799, per_field: true} %Hui.Query.FacetRange{ end: 1799, gap: &quot;+10YEARS&quot;, hardend: nil, include: nil, method: nil, other: nil, per_field: true, range: &quot;year&quot;, start: 1700 } iex&gt; x |&gt; Hui.Encoder.encode &quot;f.year.facet.range.end=1799&amp;f.year.facet.range.gap=%2B10YEARS&amp;facet.range=year&amp;f.year.facet.range.start=1700&quot; # another range iex&gt; y = %Hui.Query.FacetRange{range: &quot;price&quot;, gap: &quot;10&quot;, start: 0, end: 100, per_field: true} %Hui.Query.FacetRange{ end: 100, gap: &quot;10&quot;, hardend: nil, include: nil, method: nil, other: nil, per_field: true, range: &quot;price&quot;, start: 0 } iex&gt; z = %Hui.Query.Facet{field: &quot;type&quot;, range: [x, y]} # field and multiple ranges faceting %Hui.Query.Facet{ contains: nil, &quot;contains.ignoreCase&quot;: nil, &quot;enum.cache.minDf&quot;: nil, excludeTerms: nil, exists: nil, facet: true, field: &quot;type&quot;, interval: nil, limit: nil, matches: nil, method: nil, mincount: nil, missing: nil, offset: nil, &quot;overrequest.count&quot;: nil, &quot;overrequest.ratio&quot;: nil, pivot: nil, &quot;pivot.mincount&quot;: nil, prefix: nil, query: nil, range: [ %Hui.Query.FacetRange{ end: 1799, gap: &quot;+10YEARS&quot;, hardend: nil, include: nil, method: nil, other: nil, per_field: true, range: &quot;year&quot;, start: 1700 }, %Hui.Query.FacetRange{ end: 100, gap: &quot;10&quot;, hardend: nil, include: nil, method: nil, other: nil, per_field: true, range: &quot;price&quot;, start: 0 } ], sort: nil, threads: nil } iex&gt; z |&gt; Hui.Encoder.encode &quot;facet=true&amp;facet.field=type&amp;f.year.facet.range.end=1799&amp;f.year.facet.range.gap=%2B10YEARS&amp;facet.range=year&amp;f.year.facet.range.start=1700&amp;f.price.facet.range.end=100&amp;f.price.facet.range.gap=10&amp;facet.range=price&amp;f.price.facet.range.start=0&quot;","ref":"Hui.Query.FacetRange.html","title":"Hui.Query.FacetRange","type":"module"},{"doc":"","ref":"Hui.Query.FacetRange.html#new/0","title":"Hui.Query.FacetRange.new/0","type":"function"},{"doc":"","ref":"Hui.Query.FacetRange.html#new/4","title":"Hui.Query.FacetRange.new/4","type":"function"},{"doc":"Struct for range faceting parameters, use in conjunction with the faceting struct -Hui.Query.Facet.t/0.","ref":"Hui.Query.FacetRange.html#t:t/0","title":"Hui.Query.FacetRange.t/0","type":"type"},{"doc":"Struct related to the common parameters of results highlighting.See :Highlighting parameters","ref":"Hui.Query.Highlight.html","title":"Hui.Query.Highlight","type":"module"},{"doc":"","ref":"Hui.Query.Highlight.html#new/0","title":"Hui.Query.Highlight.new/0","type":"function"},{"doc":"","ref":"Hui.Query.Highlight.html#new/3","title":"Hui.Query.Highlight.new/3","type":"function"},{"doc":"Struct for results highlighting","ref":"Hui.Query.Highlight.html#t:t/0","title":"Hui.Query.Highlight.t/0","type":"type"},{"doc":"Struct related to results highlighting - Fast Vector highlighter","ref":"Hui.Query.HighlighterFastVector.html","title":"Hui.Query.HighlighterFastVector","type":"module"},{"doc":"","ref":"Hui.Query.HighlighterFastVector.html#new/0","title":"Hui.Query.HighlighterFastVector.new/0","type":"function"},{"doc":"","ref":"Hui.Query.HighlighterFastVector.html#new/3","title":"Hui.Query.HighlighterFastVector.new/3","type":"function"},{"doc":"Struct for fast vector highlighter, use in conjunction with the highlighting struct -Hui.Query.Highlight.t/0.","ref":"Hui.Query.HighlighterFastVector.html#t:t/0","title":"Hui.Query.HighlighterFastVector.t/0","type":"type"},{"doc":"Struct related to results highlighting - Original highlighter","ref":"Hui.Query.HighlighterOriginal.html","title":"Hui.Query.HighlighterOriginal","type":"module"},{"doc":"","ref":"Hui.Query.HighlighterOriginal.html#new/0","title":"Hui.Query.HighlighterOriginal.new/0","type":"function"},{"doc":"","ref":"Hui.Query.HighlighterOriginal.html#new/3","title":"Hui.Query.HighlighterOriginal.new/3","type":"function"},{"doc":"Struct for original highlighter, use in conjunction with the highlighting struct -Hui.Query.Highlight.t/0.","ref":"Hui.Query.HighlighterOriginal.html#t:t/0","title":"Hui.Query.HighlighterOriginal.t/0","type":"type"},{"doc":"Struct related to results highlighting - Unified Highlighter.","ref":"Hui.Query.HighlighterUnified.html","title":"Hui.Query.HighlighterUnified","type":"module"},{"doc":"","ref":"Hui.Query.HighlighterUnified.html#new/0","title":"Hui.Query.HighlighterUnified.new/0","type":"function"},{"doc":"","ref":"Hui.Query.HighlighterUnified.html#new/2","title":"Hui.Query.HighlighterUnified.new/2","type":"function"},{"doc":"Struct for unified highlighter, use in conjunction with the highlighting struct -Hui.Query.Highlight.t/0.","ref":"Hui.Query.HighlighterUnified.html#t:t/0","title":"Hui.Query.HighlighterUnified.t/0","type":"type"},{"doc":"Struct related to MoreLikeThis query.","ref":"Hui.Query.MoreLikeThis.html","title":"Hui.Query.MoreLikeThis","type":"module"},{"doc":"","ref":"Hui.Query.MoreLikeThis.html#new/0","title":"Hui.Query.MoreLikeThis.new/0","type":"function"},{"doc":"","ref":"Hui.Query.MoreLikeThis.html#new/5","title":"Hui.Query.MoreLikeThis.new/5","type":"function"},{"doc":"Struct for MoreLikeThis query.","ref":"Hui.Query.MoreLikeThis.html#t:t/0","title":"Hui.Query.MoreLikeThis.t/0","type":"type"},{"doc":"Struct for spell checking query.","ref":"Hui.Query.SpellCheck.html","title":"Hui.Query.SpellCheck","type":"module"},{"doc":"","ref":"Hui.Query.SpellCheck.html#new/0","title":"Hui.Query.SpellCheck.new/0","type":"function"},{"doc":"","ref":"Hui.Query.SpellCheck.html#new/2","title":"Hui.Query.SpellCheck.new/2","type":"function"},{"doc":"Struct for spell checking","ref":"Hui.Query.SpellCheck.html#t:t/0","title":"Hui.Query.SpellCheck.t/0","type":"type"},{"doc":"Struct for the default standard query parser also known as the lucene parser.See: Standard Query parser.","ref":"Hui.Query.Standard.html","title":"Hui.Query.Standard","type":"module"},{"doc":"","ref":"Hui.Query.Standard.html#new/0","title":"Hui.Query.Standard.new/0","type":"function"},{"doc":"","ref":"Hui.Query.Standard.html#new/1","title":"Hui.Query.Standard.new/1","type":"function"},{"doc":"Struct for the standard query.","ref":"Hui.Query.Standard.html#t:t/0","title":"Hui.Query.Standard.t/0","type":"type"},{"doc":"Struct for suggester query.","ref":"Hui.Query.Suggest.html","title":"Hui.Query.Suggest","type":"module"},{"doc":"","ref":"Hui.Query.Suggest.html#new/0","title":"Hui.Query.Suggest.new/0","type":"function"},{"doc":"","ref":"Hui.Query.Suggest.html#new/4","title":"Hui.Query.Suggest.new/4","type":"function"},{"doc":"Struct for suggester","ref":"Hui.Query.Suggest.html#t:t/0","title":"Hui.Query.Suggest.t/0","type":"type"},{"doc":"Struct related to Solr updating.Example alias Hui.Query alias Hui.Encoder # Update / index 2 documents, commit them within 1s iex&gt; doc1 = %{&quot;name&quot; =&gt; &quot;The Turin Horse&quot;, &quot;directed_by&quot; =&gt; [&quot;Béla Tarr&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;], &quot;id&quot; =&gt; &quot;tt1316540&quot;} %{ &quot;directed_by&quot; =&gt; [&quot;Béla Tarr&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;], &quot;id&quot; =&gt; &quot;tt1316540&quot;, &quot;name&quot; =&gt; &quot;The Turin Horse&quot; } iex&gt; doc2 = %{&quot;name&quot; =&gt; &quot;I Wish&quot;, &quot;directed_by&quot; =&gt; [&quot;Hirokazu Koreeda&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;], &quot;id&quot; =&gt; &quot;tt1650453&quot;} %{ &quot;directed_by&quot; =&gt; [&quot;Hirokazu Koreeda&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;], &quot;id&quot; =&gt; &quot;tt1650453&quot;, &quot;name&quot; =&gt; &quot;I Wish&quot; } iex&gt; x = %Query.Update{doc: [doc1, doc2], commit: true, commitWithin: 1000} %Hui.Query.Update{ commit: true, commitWithin: 1000, delete_id: nil, delete_query: nil, doc: [ %{ &quot;directed_by&quot; =&gt; [&quot;Béla Tarr&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;], &quot;id&quot; =&gt; &quot;tt1316540&quot;, &quot;name&quot; =&gt; &quot;The Turin Horse&quot; }, %{ &quot;directed_by&quot; =&gt; [&quot;Hirokazu Koreeda&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;], &quot;id&quot; =&gt; &quot;tt1650453&quot;, &quot;name&quot; =&gt; &quot;I Wish&quot; } ], expungeDeletes: nil, maxSegments: nil, optimize: nil, overwrite: nil, rollback: nil, waitSearcher: nil } iex&gt; x |&gt; Encoder.encode &quot;{\\&quot;add\\&quot;:{\\&quot;commitWithin\\&quot;:1000,\\&quot;doc\\&quot;:{\\&quot;name\\&quot;:\\&quot;The Turin Horse\\&quot;,\\&quot;id\\&quot;:\\&quot;tt1316540\\&quot;,\\&quot;genre\\&quot;:[\\&quot;Drama\\&quot;],\\&quot;directed_by\\&quot;:[\\&quot;Béla Tarr\\&quot;]}},\\&quot;add\\&quot;:{\\&quot;commitWithin\\&quot;:1000,\\&quot;doc\\&quot;:{\\&quot;name\\&quot;:\\&quot;I Wish\\&quot;,\\&quot;id\\&quot;:\\&quot;tt1650453\\&quot;,\\&quot;genre\\&quot;:[\\&quot;Drama\\&quot;],\\&quot;directed_by\\&quot;:[\\&quot;Hirokazu Koreeda\\&quot;]}},\\&quot;commit\\&quot;:{}}&quot; # Delete the documents by ID iex&gt; %Query.Update{delete_id: [&quot;tt1316540&quot;, &quot;tt1650453&quot;]} |&gt; Encoder.encode &quot;{\\&quot;delete\\&quot;:{\\&quot;id\\&quot;:\\&quot;tt1316540\\&quot;},\\&quot;delete\\&quot;:{\\&quot;id\\&quot;:\\&quot;tt1650453\\&quot;}}&quot; # Delete the documents by filter query iex&gt; %Query.Update{delete_query: &quot;id:tt*&quot;} |&gt; Encoder.encode &quot;{\\&quot;delete\\&quot;:{\\&quot;query\\&quot;:\\&quot;id:tt*\\&quot;}}&quot; # Commits the docs, make them visible and remove previously deleted docs from the index iex&gt; %Query.Update{commit: true, waitSearcher: true, expungeDeletes: true} |&gt; Encoder.encode &quot;{\\&quot;commit\\&quot;:{\\&quot;waitSearcher\\&quot;:true,\\&quot;expungeDeletes\\&quot;:true}}&quot; # Optimise the index, and keep the number of index segments 10 max iex&gt; %Query.Update{optimize: true, maxSegments: 10} |&gt; Encoder.encode &quot;{\\&quot;optimize\\&quot;:{\\&quot;maxSegments\\&quot;:10}}&quot;","ref":"Hui.Query.Update.html","title":"Hui.Query.Update","type":"module"},{"doc":"","ref":"Hui.Query.Update.html#new/0","title":"Hui.Query.Update.new/0","type":"function"},{"doc":"Struct related to Solr updating.","ref":"Hui.Query.Update.html#t:t/0","title":"Hui.Query.Update.t/0","type":"type"},{"doc":"Struct and utilities for working with Solr URLs and parameters.Use the module Hui.URL.t/0 struct to specify Solr core or collection URLs with request handlers.Hui URL endpoints # binary url = &quot;http://localhost:8983/solr/collection&quot; Hui.search(url, q: &quot;loch&quot;) # key referring to config setting url = :library Hui.search(url, q: &quot;edinburgh&quot;, rows: 10) # Hui.URL struct url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;suggest&quot;} Hui.search(url, suggest: true, &quot;suggest.dictionary&quot;: &quot;mySuggester&quot;, &quot;suggest.q&quot;: &quot;el&quot;) Hui.URL.t/0 struct also enables HTTP headers and options, e.g. HTTPoison options to be specified in keyword lists. HTTPoison options provide further controls for a request, e.g. timeout, recv_timeout, max_redirect, params etc. # setting up a header and a 10s receiving connection timeout url = %Hui.URL{url: &quot;..&quot;, headers: [{&quot;accept&quot;, &quot;application/json&quot;}], options: [recv_timeout: 10000]} Hui.search(url, q: &quot;solr rocks&quot;)","ref":"Hui.URL.html","title":"Hui.URL","type":"module"},{"doc":"Retrieve url configuration as Hui.URL.t/0 struct.Exampleiex&gt; Hui.URL.configured_url(:suggester) {:ok, %Hui.URL{handler: &quot;suggest&quot;, url: &quot;http://localhost:8983/solr/collection&quot;}}The above retrieves the following endpoint configuration e.g. from config.exs: config :hui, :suggester, url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;suggest&quot;","ref":"Hui.URL.html#configured_url/1","title":"Hui.URL.configured_url/1","type":"function"},{"doc":"Returns a configured default Solr endpoint as Hui.URL.t/0 struct. Hui.URL.default_url! %Hui.URL{handler: &quot;select&quot;, url: &quot;http://localhost:8983/solr/gettingstarted&quot;, headers: [{&quot;accept&quot;, &quot;application/json&quot;}], options: [recv_timeout: 10000]}The default endpoint can be specified in application configuration as below: config :hui, :default, url: &quot;http://localhost:8983/solr/gettingstarted&quot;, handler: &quot;select&quot;, # optional headers: [{&quot;accept&quot;, &quot;application/json&quot;}], options: [recv_timeout: 10000]","ref":"Hui.URL.html#default_url!/0","title":"Hui.URL.default_url!/0","type":"function"},{"doc":"Returns the string representation (URL path) of the given Hui.URL.t/0 struct.","ref":"Hui.URL.html#to_string/1","title":"Hui.URL.to_string/1","type":"function"},{"doc":"","ref":"Hui.URL.html#t:headers/0","title":"Hui.URL.headers/0","type":"type"},{"doc":"","ref":"Hui.URL.html#t:options/0","title":"Hui.URL.options/0","type":"type"},{"doc":"Struct for a Solr endpoint with a request handler and any associated HTTP headers and options.Example %Hui.URL{handler: &quot;suggest&quot;, url: &quot;http://localhost:8983/solr/collection&quot;}url: typical endpoint including the core or collection name. This may also be a load balancer endpoint fronting several Solr upstreams.handler: name of a Solr request handler that processes requests.headers: HTTP headers.options: e.g. HTTPoison options.","ref":"Hui.URL.html#t:t/0","title":"Hui.URL.t/0","type":"type"},{"doc":"","ref":"Hui.Query.html","title":"Hui.Query","type":"module"},{"doc":"","ref":"Hui.Query.html#t:faceting_struct/0","title":"Hui.Query.faceting_struct/0","type":"type"},{"doc":"","ref":"Hui.Query.html#t:highlighting_struct/0","title":"Hui.Query.highlighting_struct/0","type":"type"},{"doc":"","ref":"Hui.Query.html#t:misc_struct/0","title":"Hui.Query.misc_struct/0","type":"type"},{"doc":"","ref":"Hui.Query.html#t:querying_struct/0","title":"Hui.Query.querying_struct/0","type":"type"},{"doc":"","ref":"Hui.Query.html#t:solr_query/0","title":"Hui.Query.solr_query/0","type":"type"},{"doc":"","ref":"Hui.Query.html#t:solr_struct/0","title":"Hui.Query.solr_struct/0","type":"type"},{"doc":"","ref":"Hui.Query.html#t:solr_update_query/0","title":"Hui.Query.solr_update_query/0","type":"type"},{"doc":"","ref":"Hui.Query.html#t:solr_url/0","title":"Hui.Query.solr_url/0","type":"type"},{"doc":"","ref":"Hui.Error.html","title":"Hui.Error","type":"exception"},{"doc":"","ref":"Hui.Error.html#t:t/0","title":"Hui.Error.t/0","type":"type"},{"doc":"Hui 辉 Hui 辉 (&quot;shine&quot; in Chinese) is a Solr client and library for Elixir.","ref":"readme.html","title":"Hui 辉","type":"extras"},{"doc":"Hui enables Solr querying, updating and other forms of interaction in Elixir or Phoenix applications. Typical Solr data can be contained within a core (index) held on a single server or a data collection in distributed server architecture (cloud).Example - searching import Hui # arbitrary keywords query against the default configured endpoint q(&quot;scott&quot;) q(q: &quot;loch&quot;, rows: 5) # with query structs alias Hui.Query.{Standard,DisMax,Common,Facet,FacetRange,Suggest,MoreLikeThis,Highlight} url = &quot;http://localhost:8983/solr/gettingstarted&quot; search(url, [%Standard{q: &quot;author:I*&quot;}, %Facet{field: [&quot;cat&quot;, &quot;author_str&quot;], mincount: 1}]) # Suggester query, using `Hui.URL` struct suggester_url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;suggest&quot;} suggest_query = %Suggest{q: &quot;ha&quot;, count: 10, dictionary: [&quot;name_infix&quot;, &quot;ln_prefix&quot;, &quot;fn_prefix&quot;]} suggest(suggester_url, suggest_query) # DisMax SolrCloud query x = %DisMax{q: &quot;market&quot;, qf: &quot;description^2.3 title&quot;, mm: &quot;2&lt;-25% 9&lt;-3&quot;, pf: &quot;title&quot;, ps: 1, qs: 3} y = %Common{collection: &quot;library,commons&quot;, rows: 10, distrib: true, &quot;shards.tolerant&quot;: true, &quot;shards.info&quot;: true} z = %Facet{field: [&quot;cat&quot;, &quot;author_str&quot;], mincount: 1} search(url, [x, y, z]) # more elaborated faceting query range1 = %FacetRange{range: &quot;price&quot;, start: 0, end: 100, gap: 10, per_field: true} range2 = %FacetRange{range: &quot;popularity&quot;, start: 0, end: 5, gap: 1, per_field: true} z = %Facet{field: [&quot;cat&quot;, &quot;author_str&quot;], mincount: 1, range: [range1, range2]} search(url, [x, y, z]) # the above spawns a request with the following query string # # q=...&amp; # f.price.facet.range.end=100&amp; # f.price.facet.range.gap=10&amp;facet.range=price&amp; # f.price.facet.range.start=0&amp; # f.popularity.facet.range.end=5&amp; # f.popularity.facet.range.gap=1&amp; # facet.range=popularity&amp; # f.popularity.facet.range.start=0 # convenience functions search(url, &quot;apache documentation&quot;, 1, 5, &quot;stream_content_type_str:text/html&quot;, [&quot;subject&quot;]) suggest(suggester_url, &quot;ha&quot;, 5, [&quot;name_infix&quot;, &quot;ln_prefix&quot;, &quot;fn_prefix&quot;], &quot;1939&quot;)The q examples send requests to a :default configured endpoint (see Configuration below). Query parameters could be a string, arbitrary keywords or built-in query structs that provide a structured way for invoking the comprehensive and powerful features of Solr.See the API reference and Solr reference guide for more details on available search parameters.Solr endpoints, HTTP headers and optionsSolr endpoints and request handlers may be specified in multiple ways: # URL binary string Hui.search(&quot;http://localhost:8983/solr/collection&quot;, q: &quot;loch&quot;) # URL key referring to an endpoint in configuration - see &quot;Configuration&quot; Hui.search(:library, q: &quot;edinburgh&quot;, rows: 10) # URL in a struct url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;suggest&quot;} Hui.search(url, %Hui.Query.Suggest{q: &quot;el&quot;, dictionary: &quot;mySuggester&quot;})HTTP headers and options can be specified via the Hui.URL.t/0 struct. # setting up a header and a 10s receiving connection timeout url = %Hui.URL{url: &quot;..&quot;, headers: [{&quot;accept&quot;, &quot;application/json&quot;}], options: [recv_timeout: 10000]}Headers and options for a specific endpoint may also be configured - see &quot;Configuration&quot;.Example - updatingTo add, update and delete Solr documents, as well as optimised search indexes: # Specify an update handler endpoint for JSON-formatted update headers = [{&quot;Content-type&quot;, &quot;application/json&quot;}] url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;update&quot;, headers: headers} # Solr documents doc1 = %{ &quot;actors&quot; =&gt; [&quot;Ingrid Bergman&quot;, &quot;Liv Ullmann&quot;, &quot;Lena Nyman&quot;, &quot;Halvar Björk&quot;], &quot;desc&quot; =&gt; &quot;A married daughter who longs for her mother&#39;s love is visited by the latter, a successful concert pianist.&quot;, &quot;directed_by&quot; =&gt; [&quot;Ingmar Bergman&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;, &quot;Music&quot;], &quot;id&quot; =&gt; &quot;tt0077711&quot;, &quot;initial_release_date&quot; =&gt; &quot;1978-10-08&quot;, &quot;name&quot; =&gt; &quot;Autumn Sonata&quot; } doc2 = %{ &quot;actors&quot; =&gt; [&quot;Bibi Andersson&quot;, &quot;Liv Ullmann&quot;, &quot;Margaretha Krook&quot;], &quot;desc&quot; =&gt; &quot;A nurse is put in charge of a mute actress and finds that their personas are melding together.&quot;, &quot;directed_by&quot; =&gt; [&quot;Ingmar Bergman&quot;], &quot;genre&quot; =&gt; [&quot;Drama&quot;, &quot;Thriller&quot;], &quot;id&quot; =&gt; &quot;tt0060827&quot;, &quot;initial_release_date&quot; =&gt; &quot;1967-09-21&quot;, &quot;name&quot; =&gt; &quot;Persona&quot; } # Add the docs and commit them to the index immediately Hui.update(url, [doc1, doc2]) # Send documents to another pre-configured endpoint Hui.update(:updater, [doc1, doc2]) Hui.delete(url, &quot;tt0077711&quot;) # delete one doc Hui.delete(url, [&quot;tt0077711&quot;, &quot;tt0060827&quot;]) # delete a list of docs Hui.delete_by_query(url, [&quot;genre:Drama&quot;, &quot;name:Persona&quot;]) # delete via filter queriesAdvanced update requests may be issued using the Hui.Query.Update struct, as well as through any valid binary data encapsulating Solr documents and commands. # url, doc1, doc2 from the above example ... # Hui.Query.Update struct commands for updating and committing the docs to Solr immediately alias Hui.Query.Update x = %Update{doc: [doc1, doc2], commit: true, waitSearcher: true} Hui.update(url, x) # Commits docs within 5 seconds x = %Update{doc: [doc1, doc2], commitWithin: 5000, overwrite: true} Hui.update(url, x) # Commit and optimise index Hui.update(url, %Update{commit: true, waitSearcher: true, optimize: true, maxSegments: 10}) # Binary mode, e.g. delete a document via XML binary headers = [{&quot;Content-type&quot;, &quot;application/xml&quot;}] url = %Hui.URL{url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;update&quot;, headers: headers} Hui.update(url, &quot;&lt;delete&gt;&lt;id&gt;9780141981727&lt;/id&gt;&lt;/delete&gt;&quot;)See Solr reference for more details on update commands, data types and formats.Software libraryHui modules and data structures can be used for building Solr application in Elixir and Phoenix. The query struct modules provide idiomatic and structured ways for creating and encoding Solr parameters. For example, multiple filters and facet fields can be specified via list. fq: [&quot;field1&quot;, &quot;field2&quot;], field: [&quot;field1&quot;, &quot;field2&quot;], gap: 10 Elixir codes.&quot;Per-field&quot; faceting can be specified in a succinct and unified way, e.g. gap instead of the long-winded f.[fieldname].facet.range.gap (per field) or facet.range.gap (single field). Per-field usage for a particular facet can be set or unset via the per_field key (example below).Hui.Encoder protocol and Hui.Encode utility provide support for encoding query structs into binary and IO data formats. A custom query struct may be developed by implementing the Encoder protocol. alias Hui.Query.{Facet,FacetRange} %Facet{field: [&quot;type&quot;, &quot;year&quot;, &quot;subject&quot;], query: &quot;edited:true&quot;} |&gt; Hui.Encoder.encode # -&gt; &quot;facet=true&amp;facet.field=type&amp;facet.field=year&amp;facet.field=subject&amp;facet.query=edited%3Atrue&quot; # facet=true, facet prefixes are generated implicitly # a unified way to specify per-field or singe-field faceting x = %FacetRange{range: &quot;age&quot;, gap: 10, start: 0, end: 100} x |&gt; Hui.Encoder.encode # -&gt; &quot;facet.range.end=100&amp;facet.range.gap=10&amp;facet.range=age&amp;facet.range.start=0&quot; %{x | per_field: true} # toggle per field faceting |&gt; Hui.Encoder.encode # -&gt; &quot;f.age.facet.range.end=100&amp;f.age.facet.range.gap=10&amp;facet.range=age&amp;f.age.facet.range.start=0&quot;Hui.Query.Update struct enables various JSON-formatted update and grouped commands to be generated. alias Hui.Query.Update alias Hui.Encoder # doc1, doc2 are Maps of Solr documents x = %Update{doc: [doc1, doc2], commit: true, commitWithin: 1000} x |&gt; Encoder.encode # -&gt; &quot;{\\&quot;add\\&quot;:{\\&quot;commitWithin\\&quot;:1000,\\&quot;doc\\&quot;:{...}},\\&quot;add\\&quot;:{\\&quot;commitWithin\\&quot;:1000,\\&quot;doc\\&quot;:{...}},\\&quot;commit\\&quot;:{}}&quot; # Delete the documents by ID %Update{delete_id: [&quot;tt1316540&quot;, &quot;tt1650453&quot;]} |&gt; Encoder.encode # -&gt; &quot;{\\&quot;delete\\&quot;:{\\&quot;id\\&quot;:\\&quot;tt1316540\\&quot;},\\&quot;delete\\&quot;:{\\&quot;id\\&quot;:\\&quot;tt1650453\\&quot;}}&quot;The structs and their associated type spec also provide binding to and introspection of available Solr parameters. iex&gt; %Hui.Query.Facet{field: [&quot;type&quot;, &quot;year&quot;], query: &quot;year:[2000 TO NOW]&quot;} %Hui.Query.Facet{ contains: nil, &quot;contains.ignoreCase&quot;: nil, &quot;enum.cache.minDf&quot;: nil, excludeTerms: nil, exists: nil, facet: true, field: [&quot;type&quot;, &quot;year&quot;], interval: nil, limit: nil, matches: nil, method: nil, mincount: nil, missing: nil, offset: nil, &quot;overrequest.count&quot;: nil, &quot;overrequest.ratio&quot;: nil, pivot: [], &quot;pivot.mincount&quot;: nil, prefix: nil, query: &quot;year:[2000 TO NOW]&quot;, range: nil, sort: nil, threads: nil }IO data encodingTo leverage Erlang runtime and some HTTP client features for lower memory usage and increased performance, Hui.Encoder provides functions to return either string or IO data which can be sent directly to IO functions or over the socket.Parsing Solr resultsSolr results is returned encapsulated in HTTP response struct containing the Solr response. {:ok, %Hui.Http{ body: &quot;...[Solr reponse]..&quot;, headers: [ {&quot;Content-Type&quot;, &quot;application/json;charset=utf-8&quot;}, {&quot;Content-Length&quot;, &quot;4005&quot;} ], method: :get, options: [], status: 200, url: &quot;http://localhost:8983/solr/gettingstarted/select?q=%2A&quot; } }JSON response is automatically parsed and decoded as map. It is accessible via the body key. {status, resp} = Hui.q(solr_params) # getting a list of Solr documents (Map) solr_docs = resp.body[&quot;response&quot;][&quot;docs&quot;] total_hits = resp.body[&quot;response&quot;][&quot;numFound&quot;]Note: other response formats such as XML, are currently being returned in raw text.","ref":"readme.html#usage","title":"Hui 辉 - Usage","type":"extras"},{"doc":"Hui is available in Hex, the package can be installed by adding hui to your list of dependencies in mix.exs: def deps do [ {:hui, &quot;~&gt; 0.10.3&quot;} ] endThen run $ mix deps.get.Documentation can be found at https://hexdocs.pm/hui.","ref":"readme.html#installation","title":"Hui 辉 - Installation","type":"extras"},{"doc":"A default Solr endpoint may be specified in the application configuration as below: config :hui, :default, url: &quot;http://localhost:8983/solr/gettingstarted&quot;, handler: &quot;select&quot;, # optional headers: [{&quot;accept&quot;, &quot;application/json&quot;}], # optional options: [recv_timeout: 10000] # optionalHTTP headers and options may also be configured.See Hui.URL.default_url!/0.Solr provides various request handlers for many purposes (search, autosuggest, spellcheck, indexing etc.). The handlers are configured in different custom or normative names in Solr configuration, e.g. &quot;select&quot; for search queries.Additional endpoints and request handlers can be configured in Hui using arbitrary config keys (e.g. :suggester): config :hui, :suggester, url: &quot;http://localhost:8983/solr/collection&quot;, handler: &quot;suggest&quot;Use the config key in functions such as Hui.search/2, Hui.search/3 to send queries to the endpoint or retrieve URL settings from configuration e.g. Hui.URL.configured_url/1.","ref":"readme.html#configuration","title":"Hui 辉 - Configuration","type":"extras"},{"doc":"Hui is released under Apache 2 License. Check the LICENSE file for more information.","ref":"readme.html#license","title":"Hui 辉 - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Rewrite Hui.Encode.encode utility with body-recursive functions for better performanceProvide a new encode_to_iodata/1 function and implementations in Hui.Encoder protocol","ref":"changelog.html#0-10-3-2020-09-17","title":"Changelog - 0.10.3 (2020-09-17)","type":"extras"},{"doc":"Extensive test refactoring","ref":"changelog.html#0-10-2-2020-08-06","title":"Changelog - 0.10.2 (2020-08-06)","type":"extras"},{"doc":"Simpler Http client behaviour with a single dispatch callback, update HTTPoison (reference) implementationHui.Query module deprecationRefactoring and more HTTPoison dependency decoupling","ref":"changelog.html#0-10-1-2020-07-17","title":"Changelog - 0.10.1 (2020-07-17)","type":"extras"},{"doc":"New HTTP client architecture: introduce a behaviour with a HTTPoison implementationBegin HTTPoison dependency decouplingRemoval of all bang (!) functions towards a simpler core library","ref":"changelog.html#0-10-0-2020-07-06","title":"Changelog - 0.10.0 (2020-07-06)","type":"extras"},{"doc":"Remove various deprecated functions and data structsnew instantiation function for data structs","ref":"changelog.html#0-9-3-2020-05-08","title":"Changelog - 0.9.3 (2020-05-08)","type":"extras"},{"doc":"New JSON Encoder protocol implementation for Hui.Query.Update structRefactor encoding utiliy functions: prep for forthcoming support of JSON request/facet APIs","ref":"changelog.html#0-9-2-2019-11-29","title":"Changelog - 0.9.2 (2019-11-29)","type":"extras"},{"doc":"New Hui.Query.Update struct for indexing documentsHui.Encoder encodes update query in JSON formatHui.Query.get/2 and Hui.Query.post/2 functions (accept built-in data structs) for HTTP requests","ref":"changelog.html#0-9-1-2019-11-19","title":"Changelog - 0.9.1 (2019-11-19)","type":"extras"},{"doc":"New query structs: Hui.Query.Standard, Hui.Query.DisMax, Hui.Query.Common, Faceting: Hui.Query.Facet, Hui.Query.FacetRange, Hui.Query.FacetInterval, Hui.Query.Highlight, Hui.Query.HighlighterFastVector, Hui.Query.HighlighterOriginal, Hui.Query.HighlighterUnified, Hui.Query.SpellCheck, Hui.Query.Suggest Hui.Query.MoreLikeThisHui.Encoder protocol and implementation for encoding the new query structs","ref":"changelog.html#0-9-0-2019-11-06","title":"Changelog - 0.9.0 (2019-11-06)","type":"extras"},{"doc":"update dependencies: newer versions of bypass, httpoison, cowboy","ref":"changelog.html#0-8-3-0-8-4-2019-10-03","title":"Changelog - 0.8.3, 0.8.4 (2019-10-03)","type":"extras"},{"doc":"update/3, update!/3 functions for adding and updating Solr docsdelete/3, delete!/3, delete_by_query/3, delete_by_query!/3 functions for deleting Solr docscommit/2, commit!/2 functions for committing Solr docs to index","ref":"changelog.html#0-8-2-2018-10-09","title":"Changelog - 0.8.2 (2018-10-09)","type":"extras"},{"doc":"Documentation, README and doctests for Solr updating via Hui.U struct","ref":"changelog.html#0-8-1-2018-10-08","title":"Changelog - 0.8.1 (2018-10-08)","type":"extras"},{"doc":"Solr updating via struct: Request.update/3 now accepts a Hui.U struct for adding, deleting and committing documents, as well as optimising indexes","ref":"changelog.html#0-8-0-2018-10-06","title":"Changelog - 0.8.0 (2018-10-06)","type":"extras"},{"doc":"Enable Solr updating with binary data (JSON, XML update docs) via Request.update/3 function","ref":"changelog.html#0-7-0-2018-10-03","title":"Changelog - 0.7.0 (2018-10-03)","type":"extras"},{"doc":"Convenience functions for search and suggester requests (q/6, search/7, suggest/5)Bangified all main module functions (q!/1, search!/2, spellcheck!/2, spellcheck!/3, suggest!/2, mlt!/3)Deprecate the standard query + faceting functions (q/2, search/3) as these are now provided through the more general-purpose functions (q/1, search/2)","ref":"changelog.html#0-6-3-2018-09-28","title":"Changelog - 0.6.3 (2018-09-28)","type":"extras"},{"doc":"Introduce a &quot;bang&quot; feature via an additional boolean parameter in Request.search/3 for implementing bangified functions laterDeprecate Hui.Search module which is replaced by Hui.Request to provide update functions laterRefactor search tests with a helper function that tests search/2 in both Hui and Hui.Request modulesRefactor and fix typespec issues with DialyzirCode coverage metric via ExCoveralls and coveralls.io","ref":"changelog.html#0-6-2-2018-09-26","title":"Changelog - 0.6.2 (2018-09-26)","type":"extras"},{"doc":"Provide cursorMark parameter for deep paging in Hui.QDefine and use a custom exception Hui.Error, instead of the mixed usage of HTTPoison and arbitrary error text responses","ref":"changelog.html#0-6-1-2018-09-24","title":"Changelog - 0.6.1 (2018-09-24)","type":"extras"},{"doc":"Support SolrCloud request parameters such as 'collection', 'shards', 'shards.tolerant' in Hui.Q and distributed search","ref":"changelog.html#0-6-0-2018-09-21","title":"Changelog - 0.6.0 (2018-09-21)","type":"extras"},{"doc":"Support autosuggest (suggester) query via suggest/2Support spell checking query via spellcheck/3Support MoreLikeThis query via mlt/3Suggester query via Hui.S structSpell checking query via Hui.Sp structMoreLikeThis query via Hui.M struct","ref":"changelog.html#0-5-7-2018-09-21","title":"Changelog - 0.5.7 (2018-09-21)","type":"extras"},{"doc":"Results highlighting (snippets) query via Hui.H structUnified, Original, Fast Vector results highlighting (snippets) via Hui.H1/H2/H3 structs","ref":"changelog.html#0-5-6-2018-09-20","title":"Changelog - 0.5.6 (2018-09-20)","type":"extras"},{"doc":"q/1, search/2 to generally accept a list of current and forthcoming Hui structs for more complex querying, e.g. DisMaxDisMax (Maximum Disjunction) and Extended DisMax (eDisMax) query now via a new Hui.D structDeprecate DisMax parameters from Hui.Q struct","ref":"changelog.html#0-5-5-2018-09-20","title":"Changelog - 0.5.5 (2018-09-20)","type":"extras"},{"doc":"Maximum Disjunction (DisMax) query via Hui.Q struct","ref":"changelog.html#0-5-4-2018-09-16","title":"Changelog - 0.5.4 (2018-09-16)","type":"extras"},{"doc":"Support JSON and XML response writer parameters in Hui.Q struct","ref":"changelog.html#0-5-3-2018-09-14","title":"Changelog - 0.5.3 (2018-09-14)","type":"extras"},{"doc":"New q/2, search/3 features for structured querying and faceting - Solr standard parsersearch/2, q/1 accepts query struct (Hui.Q) parametersSearch.search/2 works with query and faceting structs (Hui.Q, Hui.F) parameters","ref":"changelog.html#0-5-2-2018-09-13","title":"Changelog - 0.5.2 (2018-09-13)","type":"extras"},{"doc":"URL encoder renders faceting structs to string according to Solr prefix syntax e.g. &quot;field&quot; -&gt; facet.fieldURL encoder for &quot;per field&quot; faceting (ranges, intervals) use cases, e.g. &quot;gap&quot; -&gt; f.[field].range.gapConsolidate URL.encode_query/1; deprecate Q.encode_queryImprove succinctness of range and interval faceting struct: remove redundant words, e.g. &quot;range.start&quot;, &quot;range.end&quot; -&gt; &quot;start&quot;, &quot;end&quot; etc.","ref":"changelog.html#0-5-1-2018-09-12","title":"Changelog - 0.5.1 (2018-09-12)","type":"extras"},{"doc":"Introduce struct modules for standard query and faceting parameters","ref":"changelog.html#0-5-0-2018-09-11","title":"Changelog - 0.5.0 (2018-09-11)","type":"extras"},{"doc":"Enable HTTP headers and options per endpoint configuration","ref":"changelog.html#0-4-2-2018-09-06","title":"Changelog - 0.4.2 (2018-09-06)","type":"extras"},{"doc":"Decode and return Solr JSON response as Map","ref":"changelog.html#0-4-1-2018-09-04","title":"Changelog - 0.4.1 (2018-09-04)","type":"extras"},{"doc":"Support HTTP headers and options specificationRemove Hui.Search.search/1 (cf. search/2)q/1 shortcut for search(:default, query)","ref":"changelog.html#0-4-0-2018-09-03","title":"Changelog - 0.4.0 (2018-09-03)","type":"extras"},{"doc":"Multiple Solr endpoints configuration and searchingApache 2 license","ref":"changelog.html#0-3-0-2018-09-01","title":"Changelog - 0.3.0 (2018-09-01)","type":"extras"},{"doc":"First release.Solr search capability","ref":"changelog.html#0-2-0-2018-08-31","title":"Changelog - 0.2.0 (2018-08-31)","type":"extras"}]